#include <avr/io.h>
#include <string.h>
#include "pwm.h"

#if PWM_BITS < 9 || PWM_BITS > 16 
#error Only 9 .. 16 Bit PWM implemented !!!
#endif

uint16_t pwm_val[PWM_CHANNEL];

void pwm_init()
{
  PWM_PORT = PWM_POL ? 0 : 0xFF;
  PWM_PORT_oe = 0xFF;
  OCR1A = (1UL << PWM_BITS) - 2;                // 0x0FFE at 12 bit
  TCCR1B = 1<<WGM12 | 1<<CS00;                  // CTC-mode, F_CPU / 1
  TIMSK1 = 1<<OCIE1A | 1<<OCIE1B;
}

void pwm_set()
{
  uint16_t *pval = pwm_val; 
  uint8_t pdat[PWM_BITS] = {0};               // optimized to register
  
  for( uint8_t mask = 1; mask; mask <<= 1 ){
    uint16_t v = *pval++;
#define MOVE_BIT(x) if( PWM_BITS > x && (PWM_POL ? v : ~v) & 1<<x ) pdat[x] |= mask
    MOVE_BIT(0);  MOVE_BIT(1);  MOVE_BIT(2);  MOVE_BIT(3);
    MOVE_BIT(4);  MOVE_BIT(5);  MOVE_BIT(6);  MOVE_BIT(7);
    MOVE_BIT(8);  MOVE_BIT(9);  MOVE_BIT(10); MOVE_BIT(11);
    MOVE_BIT(12); MOVE_BIT(13); MOVE_BIT(14); MOVE_BIT(15);
  } 
#define STORE_PWM(x) if( PWM_BITS > x ) pwm_data[x]  = pdat[x]
  STORE_PWM(0);  STORE_PWM(1);  STORE_PWM(2);  STORE_PWM(3);
  STORE_PWM(4);  STORE_PWM(5);  STORE_PWM(6);  STORE_PWM(7);
  STORE_PWM(8);  STORE_PWM(9);  STORE_PWM(10); STORE_PWM(11);
  STORE_PWM(12); STORE_PWM(13); STORE_PWM(14); STORE_PWM(15);
}
